image: docker:latest
services:
  - docker:dind
cache:
  paths:
    - .m2/repository/
    - target/


stages:          # List of stages for jobs, and their order of execution
  - build
  - test
  - publish
  - deploy
  - dast

include:
  - template: Security/SAST.gitlab-ci.yml      #passed
  - template: Dependency-Scanning.gitlab-ci.yml      #passed
  - template: License-Scanning.gitlab-ci.yml      #passed
  - template: Container-Scanning.gitlab-ci.yml       # will be fixed later
  - template: Code-Quality.gitlab-ci.yml       #passed
  - template: Secret-Detection.gitlab-ci.yml
  - template: DAST.gitlab-ci.yml



#maven-build:
#  image: maven:3-jdk-8
#  stage: build
#  script:
#    - mvn package -Dmaven.repo.local=./.m2/repository
#  artifacts:
#    paths:
#      - .m2/
#      - target/

secret_detection:
  stage: test
  variables:
    SECRET_DETECTION_HISTORIC_SCAN: "true"

sast:
  stage: test
  variables:
    CI_DEBUG_TRACE: "true"
    FAIL_NEVER: 1
  artifacts:
    reports:
     sast: gl-sast-report.json

dependency_scanning:
  stage: test
  variables:
    CI_DEBUG_TRACE: "true"


container_scanning:
  stage: test
  variables:
    DOCKER_IMAGE: registry.gitlab.com/hackerox.kali/paiement:latest

Unit_tests:
  image: maven:3-jdk-8
  stage: test
  script:
    - mvn verify

#docker-build:
#  stage: publish
#  before_script:
#    - docker login -u "$CI_REGISTRY_USER" -p "$CI_REGISTRY_PASSWORD" $CI_REGISTRY
#  script:
#    - docker build --pull -t "$CI_REGISTRY_IMAGE" .
#    - docker push "$CI_REGISTRY_IMAGE"

#k8s-deploy:
#  image: google/cloud-sdk
#  stage: deploy
#  script:
#  - echo "$GOOGLE_KEY" > key.json # Google Cloud service account key
#  - gcloud auth activate-service-account --key-file key.json
#  - gcloud config set compute/zone us-central1-c
#  - gcloud config set project macro-gadget-340410
#  - gcloud config set container/use_client_certificate False
#  - gcloud container clusters get-credentials autopilot-cluster-1
#  - kubectl delete secret registry.gitlab.com --ignore-not-found=true
#  - kubectl create secret docker-registry registry.gitlab.com --docker-server=https://registry.gitlab.com --docker-username=hackerox.kali --docker-password=$REGISTRY_PASSWD --docker-email=hackerox.kali@gmail.com
#  - kubectl apply -f deployment.yml --validate=false

dast:
  stage: dast
  variables:
    DAST_WEBSITE: http://35.222.31.169:80
    DAST_SKIP_TARGET_CHECK: "true"
